> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Update an e-invoicing service provider

PUT https://rest.test.zuora.com/v1/einvoice/service-providers/{key}
Content-Type: application/json

Updates information about an e-invoicing service privider.

**Note**: This operation is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/e-invoicing/put-update-e-invoicing-service-provider

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `key` (string, required) — The unique ID or number of the e-invoicing service provider that you want to update.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects an UpdateEInvoicingServiceProviderRequest.

- `companyIdentifier` (string, optional) — The identifier of the company used to create a sender system ID, which serves to identify the system where the transactions are sent.
- `name` (string, optional) — The name of the e-invoicing service provider.
- `test` (boolean, optional) — Whether the e-invoicing service provider's configuration is intended for testing. - If you set this field to `true`, requests are directed to the testing integration endpoints. - If you set this field to `false`, requests are directed to the production integration endpoints.
- `apiKey` (string, optional) — The API key is used to authenticate the e-invoicing service provider's requests. This field only applies to the Sovos or Avalara service provider.
- `secretKey` (string, optional) — The secret key is used to authenticate the e-invoicing service provider's requests. This field only applies to the Sovos or Avalara service provider.
- `use_certificate` (boolean, optional, default: true) — This field is used to indicate whether the *clientCertificate*, `clientCertificateType`, and `clientCertificatePassord` fields need to be supplied in the request. **Note:** If the flag is `true`, the TLS endpoint config is enabled. If the flag is `false`, the Non-TLS config endpoint is enabled. A TLS certificate and password are no longer required for integration with Sovos. Zuora now uses token-based authentication for all supported countries, including India.
- `clientCertificate` (string, optional) — The client certificate is used to authenticate the e-invoicing service provider's requests, which should be in base64 encoded format. This field only applies to the Sovos service provider.
- `clientCertificateType` (string, optional, default: PKCS12) — The client certificate type is used to specify the type of the client certificate. This field only applies to the Sovos service provider.
- `clientCertificatePassword` (string, optional) — The client certificate password is the password to protect the client certificate. This field only applies to the Sovos service provider.

## Response

### 200

OK

- `companyIdentifier` (string, optional) — The identifier of the company used to create a sender system ID, which serves to identify the system where the transactions are sent.
- `id` (string, optional) — The ID of the e-invoicing service provider.
- `name` (string, optional) — The name of the e-invoicing service provider.
- `provider` (enum, optional) — The name of the e-invoicing service provider that can help you generate e-invoice files for billing documents.
  - Allowed values: `Sovos`, `PEPPOL`, `Avalara`
- `serviceProviderNumber` (string, optional) — The unique number of the e-invoicing service provider.
- `test` (boolean, optional) — Whether the e-invoicing service provider's configuration is intended for testing. - If you set this field to `true`, requests are directed to the testing integration endpoints. - If you set this field to `false`, requests are directed to the production integration endpoints.
- `apiKey` (string, optional) — The API key is used to authenticate the e-invoicing service provider's requests. This field only applies to the Sovos or Avalara service provider.
- `use_certificate` (boolean, optional, default: true) — This field is used to indicate whether the `clientCertificate`, `clientCertificateType`, and `clientCertificatePassord` fields need to be supplied in the request. **Note:** If the flag is `true`, the TLS endpoint config is enabled. If the flag is `false`, the Non-TLS config endpoint is enabled. A TLS certificate and password are no longer required for integration with Sovos. Zuora now uses token-based authentication for all supported countries, including India.
- `clientCertificate` (string, optional) — The client certificate is used to authenticate the e-invoicing service provider's requests, which should be in base64 encoded format. This field only applies to the Sovos service provider.
- `clientCertificateType` (string, optional, default: PKCS12) — The client certificate type is used to authenticate the e-invoicing service provider's requests. This field only applies to the Sovos service provider.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "companyIdentifier": "CompanySample1",
  "name": "Sovos e-invoice service",
  "test": false,
  "apiKey": "ApiKeySample",
  "secretKey": "SecretKey",
  "use_certificate": false,
  "clientCertificate": "U3dhZ2dlciByb2Nrcw==",
  "clientCertificateType": "PKCS12",
  "clientCertificatePassword": "ClientCertificatePassword"
}
```

**Response**

```json
{
  "companyIdentifier": "CompanySample1",
  "id": "4028948972a2bf990172bc9b27724eef",
  "name": "Sovos e-invoice service",
  "provider": "Sovos",
  "serviceProviderNumber": "EISP-00000001",
  "test": true,
  "apiKey": "SampleApiKey",
  "use_certificate": false,
  "clientCertificate": "U3dhZ2dlciByb2Nrcw==",
  "clientCertificateType": "PKCS12"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/einvoice/service-providers/key"

payload = {
    "companyIdentifier": "CompanySample1",
    "name": "Sovos e-invoice service",
    "test": False,
    "apiKey": "ApiKeySample",
    "secretKey": "SecretKey",
    "use_certificate": False,
    "clientCertificate": "U3dhZ2dlciByb2Nrcw==",
    "clientCertificateType": "PKCS12",
    "clientCertificatePassword": "ClientCertificatePassword"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/einvoice/service-providers/key';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"companyIdentifier":"CompanySample1","name":"Sovos e-invoice service","test":false,"apiKey":"ApiKeySample","secretKey":"SecretKey","use_certificate":false,"clientCertificate":"U3dhZ2dlciByb2Nrcw==","clientCertificateType":"PKCS12","clientCertificatePassword":"ClientCertificatePassword"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/einvoice/service-providers/key"

	payload := strings.NewReader("{\n  \"companyIdentifier\": \"CompanySample1\",\n  \"name\": \"Sovos e-invoice service\",\n  \"test\": false,\n  \"apiKey\": \"ApiKeySample\",\n  \"secretKey\": \"SecretKey\",\n  \"use_certificate\": false,\n  \"clientCertificate\": \"U3dhZ2dlciByb2Nrcw==\",\n  \"clientCertificateType\": \"PKCS12\",\n  \"clientCertificatePassword\": \"ClientCertificatePassword\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/einvoice/service-providers/key")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"companyIdentifier\": \"CompanySample1\",\n  \"name\": \"Sovos e-invoice service\",\n  \"test\": false,\n  \"apiKey\": \"ApiKeySample\",\n  \"secretKey\": \"SecretKey\",\n  \"use_certificate\": false,\n  \"clientCertificate\": \"U3dhZ2dlciByb2Nrcw==\",\n  \"clientCertificateType\": \"PKCS12\",\n  \"clientCertificatePassword\": \"ClientCertificatePassword\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/einvoice/service-providers/key")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"companyIdentifier\": \"CompanySample1\",\n  \"name\": \"Sovos e-invoice service\",\n  \"test\": false,\n  \"apiKey\": \"ApiKeySample\",\n  \"secretKey\": \"SecretKey\",\n  \"use_certificate\": false,\n  \"clientCertificate\": \"U3dhZ2dlciByb2Nrcw==\",\n  \"clientCertificateType\": \"PKCS12\",\n  \"clientCertificatePassword\": \"ClientCertificatePassword\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/einvoice/service-providers/key', [
  'body' => '{
  "companyIdentifier": "CompanySample1",
  "name": "Sovos e-invoice service",
  "test": false,
  "apiKey": "ApiKeySample",
  "secretKey": "SecretKey",
  "use_certificate": false,
  "clientCertificate": "U3dhZ2dlciByb2Nrcw==",
  "clientCertificateType": "PKCS12",
  "clientCertificatePassword": "ClientCertificatePassword"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/einvoice/service-providers/key");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"companyIdentifier\": \"CompanySample1\",\n  \"name\": \"Sovos e-invoice service\",\n  \"test\": false,\n  \"apiKey\": \"ApiKeySample\",\n  \"secretKey\": \"SecretKey\",\n  \"use_certificate\": false,\n  \"clientCertificate\": \"U3dhZ2dlciByb2Nrcw==\",\n  \"clientCertificateType\": \"PKCS12\",\n  \"clientCertificatePassword\": \"ClientCertificatePassword\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "companyIdentifier": "CompanySample1",
  "name": "Sovos e-invoice service",
  "test": false,
  "apiKey": "ApiKeySample",
  "secretKey": "SecretKey",
  "use_certificate": false,
  "clientCertificate": "U3dhZ2dlciByb2Nrcw==",
  "clientCertificateType": "PKCS12",
  "clientCertificatePassword": "ClientCertificatePassword"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/einvoice/service-providers/key")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```